/*EMETTEUR*******************************************************
 émission d’une valeur integer via module nRF24L01
 */
//#include <MirfSpiDriver.h>
#include <SPI.h> // gestion du bus SPI
#include <Mirf.h> // gestion de la communication
#include <nRF24L01.h> // définition des registres du nRF24L01
#include <MirfHardwareSpiDriver.h> // communication SPI nRF24L01

char myConcatenation[40];
String myStringArray="STOP_";
int myInt3=0;
#define FASTADC 1
// defines for setting and clearing register bits for FASTADC
#ifndef cbi 
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#endif
#ifndef sbi
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#endif


void setup()
{
  Serial.begin(9600);
  Mirf.cePin = 8; // CE sur broche 8
  Mirf.csnPin = 7; // CSN sur broche 7
  Mirf.spi = &MirfHardwareSpi; // utilisation du port SPI hardware
  Mirf.init(); // initialise le module SPI
  Mirf.channel = 120; // utilisation canal 0 pour communiquer (128 canaux disponible, de 0 à 127)
  // RF_SETUP=0000abcd : a=1–>2Mb/s, a=0–>1Mb/s; puissance émission bc=00–>-18 dBm, bc=01–>-12dBm, bc=10–>-6dBm, bc=11–>0dBm;
  // d=0 pas de gain sur le bruit en réception
  Mirf.configRegister(RF_SETUP, 0x06); // 1 Mb/s et 0 dBm (puissance maximum)
  Mirf.setTADDR((byte *)"serve"); // définition adresse sur 5 octets du recepteur  carte Arduino
  //qui reçoit de T
  Mirf.setRADDR((byte *)"clien"); // définition adresse sur 5 octets de l emetteur carte Arduino
  //qui envoie sur R
  Mirf.payload = 32; // = 2, déclaration taille du message à transmettre, max 32 octets
  Mirf.config(); // configure le canal et la taille du message
  delay(100);
  // ************FASTADC settings, 32 µs for conversion
#if FASTADC// ex: 16Mhz/128= 125KHZ, 13 adc clocks needed, adc Prescale settings
  //125/13=9600Hz à la base soit 105 µs
  //pour 16: 16000000/(16*13)=76923hz 13µS
  //pour 32: 16000000/(32*13)=38461hz 26µs
  //pour 64: 16000000/(64*13)=19230hz 52µs
  //pour 128 104µs
  //sbi pour 1
  //cbi pour 0
  // set prescale to     16   8    4   2    128    64    32
  sbi(ADCSRA,ADPS2) ; // 1    0    0   0     1      1    1
  cbi(ADCSRA,ADPS1) ; // 0    1    1   0     1      1    0
  sbi(ADCSRA,ADPS0) ; // 0    1    0   1     1      0    1
#endif//here I use a prescale of 16
}

void loop()
{
  while(Mirf.isSending())
  {
    // en cours d’émission
    delay(5);
  }

  //Multi analog input read in pseudo real time
  ADMUX = 0x40;//ADC0  selections of the ADCs for A0, LEFT/RIGHT
  bitSet (DIDR0,ADC1D); //disable the others ADC
  bitSet (DIDR0,ADC2D);
  bitSet (DIDR0,ADC3D);
  bitSet (DIDR0,ADC4D);
  bitSet (DIDR0,ADC5D);
  int myInt=analogRead(A0);
  
  ADMUX = 0x41;//ADC1 selections of the ADCs FOR A1, SPEED INCREASE/DECREASE, FRONT/BACK
  bitSet (DIDR0,ADC0D);//disable the others ADC
  bitSet (DIDR0,ADC2D);
  bitSet (DIDR0,ADC3D);
  bitSet (DIDR0,ADC4D);
  bitSet (DIDR0,ADC5D);
  int myInt2=analogRead(A1);
  myInt3=myInt2;//
  if ((505<myInt2 && myInt2<=1023) && (525<myInt && myInt<=1023) ) {
    myInt3=myInt3-503;
    myStringArray="FWLFT";
  }
  if ((505<myInt2 && myInt2<=1023) && (0<=myInt && myInt<=521) ) {
    myInt3=myInt3-503;
    myStringArray="FWRGT";
  }
  if ((505<myInt2 && myInt2<=1023) && (myInt==522 | myInt==523 | myInt==524) ) {
    myInt3=myInt3-503;
    myStringArray="FW___";
  }
  if ((myInt2==502 | myInt2==503 | myInt2==504)){
    myInt3=0;
    myStringArray="STOP_";
  }
  if ((0<=myInt2 && myInt2<=501)&& (525<myInt && myInt<=1023) ){
    myInt3=501-myInt3;
    myStringArray="RVLFT";
  }
  if ((0<=myInt2 && myInt2<=501)&& (0<=myInt && myInt<=521) ){
    myInt3=501-myInt3;
    myStringArray="RVRGT";
  }
  if ((0<=myInt2 && myInt2<=501)&& (myInt==522 | myInt==523 | myInt==524) ){
    myInt3=501-myInt3;
    myStringArray="RV___";
  }
  
  
  char myCharArray2[6];// bytes of char array to send
  myStringArray.toCharArray(myCharArray2,6); //string value to char array (buffer,length)
  sprintf(myConcatenation,"%s,%04d,%04d",myCharArray2,myInt,myInt2);//char, 2 decimal with leading zeros
  Mirf.send((byte *) myConcatenation);
  Serial.println(myConcatenation);
  delay(80);
}










